[type/__package_pkg_openbsd] Clean up code

remotes/origin/4.10
Takashi Yoshi 6 years ago
parent 498628d16a
commit aa456ab6c1
  1. 154
      cdist/conf/type/__package_pkg_openbsd/gencode-remote

@ -23,100 +23,98 @@
# Manage packages with pkg on OpenBSD # Manage packages with pkg on OpenBSD
# #
# Debug os_version=$(cat "${__global}/explorer/os_version")
# exec >&2 machine=$(cat "${__global}/explorer/machine")
# set -x
os_version="$(cat "$__global/explorer/os_version")" if [ -f "${__object}/parameter/version" ]; then
machine="$(cat "$__global/explorer/machine")" version=$(cat "${__object}/parameter/version")
if [ -f "$__object/parameter/version" ]; then
version="$(cat "$__object/parameter/version")"
fi fi
if [ -f "$__object/parameter/flavor" ]; then if [ -f "${__object}/parameter/flavor" ]; then
flavor="$(cat "$__object/parameter/flavor")" flavor=$(cat "${__object}/parameter/flavor")
fi fi
# do not show progress bar # Do not show progress bar
pkgopts="-x" pkgopts='-x'
if [ -f "$__object/parameter/name" ]; then name="${__object_id}"
name=$(cat "$__object/parameter/name") if [ -f "${__object}/parameter/name" ]; then
else name=$(cat "${__object}/parameter/name")
name="$__object_id"
fi fi
if [ -n "$version" ] && [ -n "$flavor" ]; then if [ -n "${version}" ] && [ -n "${flavor}" ]; then
pkgid="$name-$version-$flavor" pkgid="${name}-${version}-${flavor}"
elif [ -n "$version" ]; then elif [ -n "${version}" ]; then
pkgid="$name-$version" pkgid="${name}-${version}"
elif [ -n "$flavor" ]; then elif [ -f "${__object}/parameter/flavor" ]; then
pkgid="$name--$flavor" pkgid="${name}--${flavor}"
elif [ -f "$__object/parameter/flavor" ]; then
pkgid="$name--"
else else
pkgid="$name" pkgid="${name}"
fi fi
state_should="$(cat "$__object/parameter/state")" state_should=$(cat "${__object}/parameter/state")
pkg_version="$(cat "$__object/explorer/pkg_version")" pkg_version=$(cat "${__object}/explorer/pkg_version")
if [ -f "$__object/parameter/pkg_path" ]; then if [ -f "${__object}/parameter/pkg_path" ]; then
pkg_path="$(cat "$__object/parameter/pkg_path")" pkg_path=$(cat "${__object}/parameter/pkg_path")
else else
has_installurl=$(cat "${__object}/explorer/has_installurl") has_installurl=$(cat "${__object}/explorer/has_installurl")
if [ Xyes != X"${has_installurl}" ]; then if [ 'yes' != "${has_installurl}" ]; then
# there is no default PKG_PATH, try to provide one # There is no default PKG_PATH, try to provide one
pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/$os_version/packages/$machine/" pkg_path="ftp://ftp.openbsd.org/pub/OpenBSD/${os_version}/packages/${machine}/"
fi fi
fi
state_is="$(cat "$__object/explorer/pkg_state")"
[ "$state_is" = "$state_should" ] && exit 0
case "$state_should" in
present)
# use this because pkg_add doesn't properly handle errors
cat << eof
if [ X != X"${pkg_path}" ]; then
PKG_PATH="${pkg_path}"; export PKG_PATH
fi fi
status=\$(pkg_add "$pkgopts" "$pkgid" 2>&1)
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}$" 2>/dev/null state_is=$(cat "${__object}/explorer/pkg_state")
[ "${state_is}" = "${state_should}" ] && exit 0
# We didn't find the package in the list of 'installed packages', so it failed
# This is necessary because pkg_add doesn't return properly case "${state_should}" in
if [ \$? -ne 0 ]; then present)
if [ -z "\${status}" ]; then if [ -n "${pkg_path}" ]; then
status="Failed to add package, uncaught exception." echo "export PKG_PATH='${pkg_path}'"
fi fi
echo "Error: \$status" >&2
exit 1 # Use this because pkg_add doesn't properly handle errors
cat << EOF
status=\$(pkg_add ${pkgopts} '${pkgid}' 2>&1 || true)
if ! pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}$' 2>/dev/null
then
# We didn't find the package in the list of 'installed packages', so it failed.
# This is necessary because pkg_add doesn't return properly
if [ -z "\${status}" ]; then
status='Failed to add package, uncaught exception.'
fi
echo "Error: \${status}" >&2
exit 1
fi fi
eof EOF
;; echo 'installed' >> "${__messages_out}"
;;
absent)
# use this because pkg_add doesn't properly handle errors absent)
cat << eof # Use this because pkg_delete doesn't properly handle errors
status=\$(pkg_delete "$pkgopts" "$pkgid") cat << EOF
pkg_info -q -I "inst:$pkgid" | grep -q "^${name}-${version}.*${flavor}" 2>/dev/null status=\$(pkg_delete ${pkgopts} '${pkgid}' || true)
# We found the package in the list of 'installed packages' if pkg_info -q -I 'inst:${pkgid}' | grep -q '^${name}-${version}.*${flavor}' 2>/dev/null
# This would indicate that pkg_delete failed, send the output of pkg_delete then
if [ \$? -eq 0 ]; then # We found the package in the list of 'installed packages'.
if [ -z "\${status}" ]; then # This would indicate that pkg_delete failed, send the output of pkg_delete
status="Failed to remove package, uncaught exception."
fi if [ -z "\${status}" ]; then
echo "Error: \$status" >&2 status='Failed to remove package, uncaught exception.'
exit 1 fi
echo "Error: \${status}" >&2
exit 1
fi fi
eof EOF
;; echo 'removed' >> "${__messages_out}"
*) ;;
echo "Unknown state: $state_should" >&2 *)
echo "Unknown state: ${state_should}" >&2
exit 1 exit 1
;; ;;
esac esac

Loading…
Cancel
Save